Index: trunk/src/msvcrt/msvcrt.cpp
===================================================================
--- trunk/src/msvcrt/msvcrt.cpp	(revision 1861)
+++ trunk/src/msvcrt/msvcrt.cpp	(revision 1862)
@@ -1,3 +1,3 @@
-/* $Id: msvcrt.cpp,v 1.5 1999-11-12 11:38:40 sandervl Exp $ */
+/* $Id: msvcrt.cpp,v 1.6 1999-11-27 19:52:20 sandervl Exp $ */
 
 /*
@@ -32,4 +32,7 @@
 extern USHORT	_pctype_dll;
 extern CRTDLL_FILE _iob;
+wchar_t ** __wargv;
+wchar_t * _wpgmptr;
+wchar_t ** _wenviron;
 
 
@@ -760,4 +763,15 @@
 
 /*********************************************************************
+ *                  _atoi64    (MSVCRT.163)
+ */
+__int64 CDECL MSVCRT__atoi64(const char *s)
+{
+  dprintf(("MSVCRT: _atoi64 not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
  *                  _except_handler3  (MSVCRT.203)
  */
@@ -783,4 +797,15 @@
 
 /*********************************************************************
+ *                  _getmaxstdio    (MSVCRT.256)
+ */
+int CDECL MSVCRT__getmaxstdio( void )
+{
+  dprintf(("MSVCRT: _getmaxstdio not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
  *                  _getmbcp    (MSVCRT.257)
  */
@@ -805,4 +830,37 @@
 
 /*********************************************************************
+ *                  _heapadd    (MSVCRT.263)
+ */
+int CDECL MSVCRT__heapadd(void *v, size_t s)
+{
+  dprintf(("MSVCRT: _heapadd not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
+ *                  _i64toa    (MSVCRT.270)
+ */
+char * CDECL MSVCRT__i64toa(__int64 i1, char *s, int i2)
+{
+  dprintf(("MSVCRT: _i64toa not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
+ *                  _i64tow    (MSVCRT.271)
+ */
+wchar_t * CDECL MSVCRT__i64tow(__int64 i1, wchar_t *s, int i2)
+{
+  dprintf(("MSVCRT: _i64tow not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
  *                  _inp    (MSVCRT.273)
  */
@@ -970,4 +1028,15 @@
 
 /*********************************************************************
+ *                  _setmaxstdio    (MSVCRT.426)
+ */
+int CDECL MSVCRT__setmaxstdio(int i)
+{
+  dprintf(("MSVCRT: _setmaxstdio not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
  *                  _strncoll    (MSVCRT.453)
  */
@@ -990,4 +1059,28 @@
 }
 
+
+/*********************************************************************
+ *                  _ui64toa    (MSVCRT.472)
+ */
+/*
+char * CDECL MSVCRT__ui64toa(unsigned __int64 value, char *s, int i)
+{
+  dprintf(("MSVCRT: _ui64toa not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+*/
+
+/*********************************************************************
+ *                  _ui64tow    (MSVCRT.473)
+ */
+/*
+wchar_t * CDECL MSVCRT__ui64tow(unsigned __int64 value, wchar_t *s, int i)
+{
+  dprintf(("MSVCRT: _ui64tow not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+*/
 
 /*********************************************************************
@@ -1225,4 +1318,17 @@
 
 /*********************************************************************
+ *                  _wfindnexti64     (MSVCRT.515)
+ */
+/*
+int CDECL MSVCRT__wfindnexti64(intptr_t x, struct _wfinddatai64_t *s)
+{
+  dprintf(("MSVCRT: _wfindnexti64 not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+*/
+
+
+/*********************************************************************
  *                  _wfopen        (MSVCRT.516)
  */
@@ -1555,4 +1661,15 @@
 
 /*********************************************************************
+ *                  _wstati64          (MSVCRT.551)
+ */
+int CDECL MSVCRT__wstati64(const wchar_t *s, struct _stati64 *w)
+{
+  dprintf(("MSVCRT: _wstati64 not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
  *                  _wstrdate          (MSVCRT.552)
  */
@@ -1599,9 +1716,20 @@
 
 /*********************************************************************
- *                  _wtmpnam          (MSVCRT.555)
+ *                  _wtmpnam          (MSVCRT.558)
  */
 wchar_t * CDECL MSVCRT__wtmpnam( wchar_t *tn )
 {
   dprintf(("MSVCRT: _wtmpnam not implemented.\n"));
+  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
+  return FALSE;
+}
+
+
+/*********************************************************************
+ *                  _wtoi64          (MSVCRT.556)
+ */
+__int64 CDECL MSVCRT__wtoi64(const wchar_t *wt)
+{
+  dprintf(("MSVCRT: _wtoi64 not implemented.\n"));
   SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
   return FALSE;
Index: trunk/src/msvcrt/msvcrt.def
===================================================================
--- trunk/src/msvcrt/msvcrt.def	(revision 1861)
+++ trunk/src/msvcrt/msvcrt.def	(revision 1862)
@@ -1,3 +1,3 @@
-; $Id: msvcrt.def,v 1.6 1999-11-12 11:38:41 sandervl Exp $
+; $Id: msvcrt.def,v 1.7 1999-11-27 19:52:21 sandervl Exp $
 
 ;Created by BLAST for IBM's compiler
@@ -666,5 +666,5 @@
 ;   __unDNameEx							@137
 ;   __unguarded_readlc_active					@138
-;   __wargv							@139
+    __wargv							@139
 ;   __wgetmainargs						@140
 ;   __winitenv							@141
@@ -690,5 +690,5 @@
     _assert			= CRTDLL__assert		@161
 ;   _atodbl							@162
-;   _atoi64							@163
+    _atoi64			= _MSVCRT__atoi64		@163
 ;   _atoldbl							@164
     _beep			= CRTDLL__beep			@165
@@ -784,5 +784,5 @@
     _getdrive			= CRTDLL__getdrive		@254
     _getdrives			= CRTDLL__getdrives		@255
-;   _getmaxstdio						@256
+    _getmaxstdio		= _MSVCRT__getmaxstdio		@256
     _getmbcp			= _MSVCRT__getmbcp		@257
     _getpid			= CRTDLL__getpid		@258
@@ -791,5 +791,5 @@
     _getws			= CRTDLL__getws			@261
     _global_unwind2		= CRTDLL__global_unwind2	@262
-;   _heapadd							@263
+    _heapadd			= _MSVCRT__heapadd		@263
     _heapchk			= CRTDLL__heapchk		@264
     _heapmin			= CRTDLL__heapmin		@265
@@ -797,6 +797,6 @@
     _heapwalk			= CRTDLL__heapwalk		@268
     _hypot			= CRTDLL__hypot			@269
-;   _i64toa							@270
-;   _i64tow							@271
+    _i64toa			= _MSVCRT__i64toa		@270
+    _i64tow			= _MSVCRT__i64tow		@271
     _initterm			= _DLL_InitTerm			@272
     _inp			= _MSVCRT__inp			@273
@@ -957,5 +957,5 @@
     _setjmp			= CRTDLL__setjmp		@424
     _setjmp3			= CRTDLL__setjmp		@425 ; Not correct
-;   _setmaxstdio						@426
+    _setmaxstdio		= _MSVCRT__setmaxstdio		@426
 ;   _setmbcp							@427
     _setmode							@428
@@ -1003,6 +1003,6 @@
     _tzname			= CRTDLL__tzname    		@470
     _tzset			= CRTDLL__tzset			@471
-;   _ui64toa							@472
-;   _ui64tow							@473
+;    _ui64toa			= _MSVCRT_ui64toa		@472
+;    _ui64tow			= _MSVCRT_ui64tow		@473				@473
     _ultoa			= NTDLL__ultoa			@474
     _ultow			= _MSVCRT__ultow		@475
@@ -1035,5 +1035,5 @@
     _wcsupr			= NTDLL__wcsupr			@500
     _wctime			= _MSVCRT__wctime		@501
-;   _wenviron							@502
+    _wenviron							@502
     _wexecl			= _MSVCRT__wexecl		@503
     _wexecle			= _MSVCRT__wexecle		@504
@@ -1048,5 +1048,5 @@
 ;   _wfindfirsti64						@513
     _wfindnext			= _MSVCRT__wfindnext		@514
-;   _wfindnexti64						@515
+;    _wfindnexti64		= _MSVCRT__wfindnexti64		@515
     _wfopen			= _MSVCRT__wfopen		@516
     _wfreopen			= _MSVCRT__wfreopen		@517
@@ -1064,5 +1064,5 @@
     _wopen			= _MSVCRT__wopen		@529
     _wperror			= _MSVCRT__wperror		@530
-;   _wpgmptr							@531
+    _wpgmptr							@531
     _wpopen			= _MSVCRT__wpopen		@532
     _wputenv			= _MSVCRT__wputenv		@533
@@ -1084,5 +1084,5 @@
     _wsplitpath			= _MSVCRT__wsplitpath		@549
     _wstat			= _MSVCRT__wstat		@550
-;   _wstati64							@551
+    _wstati64			= _MSVCRT__wstati64		@551
     _wstrdate			= _MSVCRT__wstrdate		@552
     _wstrtime			= _MSVCRT__wstrtime		@553
@@ -1091,5 +1091,5 @@
     _wtmpnam			= _MSVCRT__wtmpnam		@556
     _wtoi			= NTDLL__wtoi			@557
-;   _wtoi64							@558
+    _wtoi64			= _MSVCRT__wtoi64		@558
     _wtol			= NTDLL__wtol			@559
     _wunlink			= _MSVCRT__wunlink 		@560